local tourist = LibStub("LibTourist-3.0")
local frame = CreateFrame("FRAME", "AutoraidFrame")

local OnUpdateThrottle = 0
local e_x = 9999
local e_y = 9999

local function Autoraid_OnUpdate(self, elapsed)
	OnUpdateThrottle = OnUpdateThrottle + elapsed
	if (OnUpdateThrottle >= 0.1) then
		local ArCoordX, ArCoordY = GetPlayerMapPosition("player")
		ArCoordX = ArCoordX*100
		ArCoordY = ArCoordY*100
		for instance in tourist:IterateZoneInstances(GetZoneText()) do
			local i_zone, i_x, i_y = tourist:GetEntrancePortalLocation(instance)
			if ((tourist:GetInstanceGroupSize(instance) > 5) and (sqrt ((((e_x - ArCoordX)) ^ 2) + (((e_y - ArCoordY)) ^ 2)) > sqrt ((((i_x - ArCoordX)) ^ 2) + (((i_y - ArCoordY)) ^ 2)))) then
				e_x = i_x
				e_y = i_y
			end
		end
-- IsFlying temporary convert prevention when flying over until I can figure out how to handle z axis.
		if (not IsFlying() and (sqrt ((((e_x - ArCoordX)) ^ 2) + (((e_y - ArCoordY)) ^ 2)) < .1)) then
			local partyMembers = GetNumPartyMembers()
			for i = 1, partyMembers do
				if (10 > UnitLevel("party"..i)) then 
					print("Autoraid:", ERR_RAID_DISALLOWED_BY_LEVEL)
				end
			end
			ConvertToRaid()
		end
		OnUpdateThrottle = 0
	end
end

--Temporary fallback if for whatever reason the party doesn't convert.
frame:RegisterEvent("UI_ERROR_MESSAGE")
local function eventHandler(self, event, ...)
	if (select(1,...) == ERR_RAID_GROUP_ONLY) and (IsPartyLeader()) then
		local partyMembers = GetNumPartyMembers()
		for i = 1, partyMembers do
			if (10 > UnitLevel("party"..i)) then 
				print("Autoraid:", ERR_RAID_DISALLOWED_BY_LEVEL)
			end
		end
		ConvertToRaid()
	end
end
frame:SetScript("OnUpdate", Autoraid_OnUpdate)
frame:SetScript("OnEvent", eventHandler)